diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/netanim/model/animation-interface.cc ns-3.40/src/netanim/model/animation-interface.cc
--- ns-3.39/src/netanim/model/animation-interface.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/netanim/model/animation-interface.cc	2023-09-27 13:30:37.850839600 -0700
@@ -38,7 +38,6 @@
 #endif
 #include "animation-interface.h"
 
-#include "ns3/animation-interface.h"
 #include "ns3/channel.h"
 #include "ns3/config.h"
 #include "ns3/constant-position-mobility-model.h"
@@ -136,7 +135,7 @@
     m_wifiPhyCountersPollInterval = pollInterval;
     m_wifiPhyTxDropCounterId = AddNodeCounter("WifiPhy TxDrop", AnimationInterface::DOUBLE_COUNTER);
     m_wifiPhyRxDropCounterId = AddNodeCounter("WifiPhy RxDrop", AnimationInterface::DOUBLE_COUNTER);
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         m_nodeWifiPhyTxDrop[n->GetId()] = 0;
@@ -156,7 +155,7 @@
     m_wifiMacTxDropCounterId = AddNodeCounter("WifiMac TxDrop", AnimationInterface::DOUBLE_COUNTER);
     m_wifiMacRxCounterId = AddNodeCounter("WifiMac Rx", AnimationInterface::DOUBLE_COUNTER);
     m_wifiMacRxDropCounterId = AddNodeCounter("WifiMac RxDrop", AnimationInterface::DOUBLE_COUNTER);
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         m_nodeWifiMacTx[n->GetId()] = 0;
@@ -179,7 +178,7 @@
     m_queueEnqueueCounterId = AddNodeCounter("Enqueue", AnimationInterface::DOUBLE_COUNTER);
     m_queueDequeueCounterId = AddNodeCounter("Dequeue", AnimationInterface::DOUBLE_COUNTER);
     m_queueDropCounterId = AddNodeCounter("Queue Drop", AnimationInterface::DOUBLE_COUNTER);
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         m_nodeQueueEnqueue[n->GetId()] = 0;
@@ -200,7 +199,7 @@
     m_ipv4L3ProtocolTxCounterId = AddNodeCounter("Ipv4 Tx", AnimationInterface::DOUBLE_COUNTER);
     m_ipv4L3ProtocolRxCounterId = AddNodeCounter("Ipv4 Rx", AnimationInterface::DOUBLE_COUNTER);
     m_ipv4L3ProtocolDropCounterId = AddNodeCounter("Ipv4 Drop", AnimationInterface::DOUBLE_COUNTER);
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         m_nodeIpv4Tx[n->GetId()] = 0;
@@ -441,7 +440,7 @@
 double
 AnimationInterface::GetNodeEnergyFraction(Ptr<const Node> node) const
 {
-    const EnergyFractionMap::const_iterator fractionIter = m_nodeEnergyFraction.find(node->GetId());
+    const auto fractionIter = m_nodeEnergyFraction.find(node->GetId());
     NS_ASSERT(fractionIter != m_nodeEnergyFraction.end());
     return fractionIter->second;
 }
@@ -501,7 +500,7 @@
 AnimationInterface::GetMovedNodes()
 {
     std::vector<Ptr<Node>> movedNodes;
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         NS_ASSERT(n);
@@ -574,9 +573,8 @@
 {
     NS_LOG_INFO("Writing Route Path From :" << nodeId << " To: " << destination);
     WriteXmlRp(nodeId, destination, rpElements);
-    /*for (Ipv4RoutePathElements::const_iterator i = rpElements.begin ();
-         i != rpElements.end ();
-         ++i)
+    /*
+    for (auto i = rpElements.begin (); i != rpElements.end (); ++i)
       {
         Ipv4RoutePathElement rpElement = *i;
         NS_LOG_INFO ("Node:" << rpElement.nodeId << "-->" << rpElement.nextHop.c_str ());
@@ -1125,7 +1123,7 @@
     UpdatePosition(ndev);
 
     std::list<Ptr<Packet>> pbList = pb->GetPackets();
-    for (std::list<Ptr<Packet>>::iterator i = pbList.begin(); i != pbList.end(); ++i)
+    for (auto i = pbList.begin(); i != pbList.end(); ++i)
     {
         Ptr<Packet> p = *i;
         ++gAnimUid;
@@ -1153,7 +1151,7 @@
     UpdatePosition(ndev);
 
     std::list<Ptr<Packet>> pbList = pb->GetPackets();
-    for (std::list<Ptr<Packet>>::iterator i = pbList.begin(); i != pbList.end(); ++i)
+    for (auto i = pbList.begin(); i != pbList.end(); ++i)
     {
         Ptr<Packet> p = *i;
         uint64_t animUid = GetAnimUidFromPacket(p);
@@ -1326,8 +1324,7 @@
         return;
     }
     std::vector<uint64_t> purgeList;
-    for (AnimUidPacketInfoMap::iterator i = pendingPackets->begin(); i != pendingPackets->end();
-         ++i)
+    for (auto i = pendingPackets->begin(); i != pendingPackets->end(); ++i)
     {
         AnimPacketInfo pktInfo = i->second;
         double delta = (Simulator::Now().GetSeconds() - pktInfo.m_fbTx);
@@ -1336,7 +1333,7 @@
             purgeList.push_back(i->first);
         }
     }
-    for (std::vector<uint64_t>::iterator i = purgeList.begin(); i != purgeList.end(); ++i)
+    for (auto i = purgeList.begin(); i != purgeList.end(); ++i)
     {
         pendingPackets->erase(*i);
     }
@@ -1503,9 +1500,7 @@
 AnimationInterface::AddToIpv4AddressNodeIdTable(std::vector<std::string> ipv4Addresses,
                                                 uint32_t nodeId)
 {
-    for (std::vector<std::string>::const_iterator i = ipv4Addresses.begin();
-         i != ipv4Addresses.end();
-         ++i)
+    for (auto i = ipv4Addresses.begin(); i != ipv4Addresses.end(); ++i)
     {
         AddToIpv4AddressNodeIdTable(*i, nodeId);
     }
@@ -1522,9 +1517,7 @@
 AnimationInterface::AddToIpv6AddressNodeIdTable(std::vector<std::string> ipv6Addresses,
                                                 uint32_t nodeId)
 {
-    for (std::vector<std::string>::const_iterator i = ipv6Addresses.begin();
-         i != ipv6Addresses.end();
-         ++i)
+    for (auto i = ipv6Addresses.begin(); i != ipv6Addresses.end(); ++i)
     {
         AddToIpv6AddressNodeIdTable(*i, nodeId);
     }
@@ -1592,7 +1585,7 @@
 void
 AnimationInterface::ConnectLte()
 {
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         NS_ASSERT(n);
@@ -1893,12 +1886,11 @@
 void
 AnimationInterface::WriteIpv4Addresses()
 {
-    for (NodeIdIpv4Map::const_iterator i = m_nodeIdIpv4Map.begin(); i != m_nodeIdIpv4Map.end(); ++i)
+    for (auto i = m_nodeIdIpv4Map.begin(); i != m_nodeIdIpv4Map.end(); ++i)
     {
         std::vector<std::string> ipv4Addresses;
-        std::pair<NodeIdIpv4Map::const_iterator, NodeIdIpv4Map::const_iterator> iterPair =
-            m_nodeIdIpv4Map.equal_range(i->first);
-        for (NodeIdIpv4Map::const_iterator it = iterPair.first; it != iterPair.second; ++it)
+        auto iterPair = m_nodeIdIpv4Map.equal_range(i->first);
+        for (auto it = iterPair.first; it != iterPair.second; ++it)
         {
             ipv4Addresses.push_back(it->second);
         }
@@ -1909,13 +1901,12 @@
 void
 AnimationInterface::WriteIpv6Addresses()
 {
-    for (NodeIdIpv6Map::const_iterator i = m_nodeIdIpv6Map.begin(); i != m_nodeIdIpv6Map.end();
+    for (auto i = m_nodeIdIpv6Map.begin(); i != m_nodeIdIpv6Map.end();
          i = m_nodeIdIpv6Map.upper_bound(i->first))
     {
         std::vector<std::string> ipv6Addresses;
-        std::pair<NodeIdIpv6Map::const_iterator, NodeIdIpv6Map::const_iterator> iterPair =
-            m_nodeIdIpv6Map.equal_range(i->first);
-        for (NodeIdIpv6Map::const_iterator it = iterPair.first; it != iterPair.second; ++it)
+        auto iterPair = m_nodeIdIpv6Map.equal_range(i->first);
+        for (auto it = iterPair.first; it != iterPair.second; ++it)
         {
             ipv6Addresses.push_back(it->second);
         }
@@ -1926,7 +1917,7 @@
 void
 AnimationInterface::WriteLinkProperties()
 {
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         UpdatePosition(n);
@@ -2027,7 +2018,7 @@
 void
 AnimationInterface::WriteNodes()
 {
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         NS_LOG_INFO("Update Position for Node: " << n->GetId());
@@ -2039,7 +2030,7 @@
 void
 AnimationInterface::WriteNodeColors()
 {
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         Rgb rgb = {255, 0, 0};
@@ -2054,7 +2045,7 @@
 void
 AnimationInterface::WriteNodeSizes()
 {
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         NS_LOG_INFO("Update Size for Node: " << n->GetId());
@@ -2069,7 +2060,7 @@
 {
     m_remainingEnergyCounterId =
         AddNodeCounter("RemainingEnergy", AnimationInterface::DOUBLE_COUNTER);
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> n = *i;
         if (NodeList::GetNode(n->GetId())->GetObject<EnergySource>())
@@ -2145,7 +2136,7 @@
         NS_LOG_INFO("TrackQueueCounters Completed");
         return;
     }
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         uint32_t nodeId = Ptr<Node>(*i)->GetId();
         UpdateNodeCounter(m_queueEnqueueCounterId, nodeId, m_nodeQueueEnqueue[nodeId]);
@@ -2163,7 +2154,7 @@
         NS_LOG_INFO("TrackWifiMacCounters Completed");
         return;
     }
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         uint32_t nodeId = Ptr<Node>(*i)->GetId();
         UpdateNodeCounter(m_wifiMacTxCounterId, nodeId, m_nodeWifiMacTx[nodeId]);
@@ -2184,7 +2175,7 @@
         NS_LOG_INFO("TrackWifiPhyCounters Completed");
         return;
     }
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         uint32_t nodeId = Ptr<Node>(*i)->GetId();
         UpdateNodeCounter(m_wifiPhyTxDropCounterId, nodeId, m_nodeWifiPhyTxDrop[nodeId]);
@@ -2203,7 +2194,7 @@
         NS_LOG_INFO("TrackIpv4L3ProtocolCounters Completed");
         return;
     }
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         uint32_t nodeId = Ptr<Node>(*i)->GetId();
         UpdateNodeCounter(m_ipv4L3ProtocolTxCounterId, nodeId, m_nodeIpv4Tx[nodeId]);
@@ -2224,9 +2215,7 @@
     {
         return;
     }
-    for (std::vector<Ipv4RouteTrackElement>::const_iterator i = m_ipv4RouteTrackElements.begin();
-         i != m_ipv4RouteTrackElements.end();
-         ++i)
+    for (auto i = m_ipv4RouteTrackElements.begin(); i != m_ipv4RouteTrackElements.end(); ++i)
     {
         Ipv4RouteTrackElement trackElement = *i;
         Ptr<Node> fromNode = NodeList::GetNode(trackElement.fromNodeId);
@@ -2301,7 +2290,7 @@
     }
     if (m_routingNc.GetN())
     {
-        for (NodeContainer::Iterator i = m_routingNc.Begin(); i != m_routingNc.End(); ++i)
+        for (auto i = m_routingNc.Begin(); i != m_routingNc.End(); ++i)
         {
             Ptr<Node> n = *i;
             WriteXmlRouting(n->GetId(), GetIpv4RoutingTable(n));
@@ -2309,7 +2298,7 @@
     }
     else
     {
-        for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+        for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
         {
             Ptr<Node> n = *i;
             WriteXmlRouting(n->GetId(), GetIpv4RoutingTable(n));
@@ -2496,9 +2485,7 @@
 {
     AnimXmlElement element("ip");
     element.AddAttribute("n", nodeId);
-    for (std::vector<std::string>::const_iterator i = ipv4Addresses.begin();
-         i != ipv4Addresses.end();
-         ++i)
+    for (auto i = ipv4Addresses.begin(); i != ipv4Addresses.end(); ++i)
     {
         AnimXmlElement valueElement("address");
         valueElement.SetText(*i);
@@ -2512,9 +2499,7 @@
 {
     AnimXmlElement element("ipv6");
     element.AddAttribute("n", nodeId);
-    for (std::vector<std::string>::const_iterator i = ipv6Addresses.begin();
-         i != ipv6Addresses.end();
-         ++i)
+    for (auto i = ipv6Addresses.begin(); i != ipv6Addresses.end(); ++i)
     {
         AnimXmlElement valueElement("address");
         valueElement.SetText(*i);
@@ -2544,7 +2529,7 @@
     element.AddAttribute("id", nodeId);
     element.AddAttribute("d", destination.c_str());
     element.AddAttribute("c", rpElements.size());
-    for (Ipv4RoutePathElements::const_iterator i = rpElements.begin(); i != rpElements.end(); ++i)
+    for (auto i = rpElements.begin(); i != rpElements.end(); ++i)
     {
         Ipv4RoutePathElement rpElement = *i;
         AnimXmlElement rpeElement("rpe");
@@ -2754,7 +2739,7 @@
     {
         attributeString += "=\"";
         std::string valueStr = oss.str();
-        for (std::string::iterator it = valueStr.begin(); it != valueStr.end(); ++it)
+        for (auto it = valueStr.begin(); it != valueStr.end(); ++it)
         {
             switch (*it)
             {
@@ -2804,8 +2789,7 @@
 {
     std::string elementString = "<" + m_tagName + " ";
 
-    for (std::vector<std::string>::const_iterator i = m_attributes.begin(); i != m_attributes.end();
-         ++i)
+    for (auto i = m_attributes.begin(); i != m_attributes.end(); ++i)
     {
         elementString += *i;
     }
@@ -2826,9 +2810,7 @@
         if (!m_children.empty())
         {
             elementString += "\n";
-            for (std::vector<std::string>::const_iterator i = m_children.begin();
-                 i != m_children.end();
-                 ++i)
+            for (auto i = m_children.begin(); i != m_children.end(); ++i)
             {
                 elementString += *i + "\n";
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/netanim/test/netanim-test.cc ns-3.40/src/netanim/test/netanim-test.cc
--- ns-3.39/src/netanim/test/netanim-test.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/netanim/test/netanim-test.cc	2023-09-27 13:30:37.850839600 -0700
@@ -19,7 +19,6 @@
 
 #include "unistd.h"
 
-#include "ns3/applications-module.h"
 #include "ns3/basic-energy-source.h"
 #include "ns3/core-module.h"
 #include "ns3/internet-module.h"
@@ -28,6 +27,7 @@
 #include "ns3/point-to-point-layout-module.h"
 #include "ns3/point-to-point-module.h"
 #include "ns3/simple-device-energy-model.h"
+#include "ns3/udp-echo-helper.h"
 
 #include <iostream>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/application-container.cc ns-3.40/src/network/helper/application-container.cc
--- ns-3.39/src/network/helper/application-container.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/application-container.cc	2023-09-27 13:30:37.850839600 -0700
@@ -69,7 +69,7 @@
 void
 ApplicationContainer::Add(ApplicationContainer other)
 {
-    for (Iterator i = other.Begin(); i != other.End(); i++)
+    for (auto i = other.Begin(); i != other.End(); i++)
     {
         m_applications.push_back(*i);
     }
@@ -91,7 +91,7 @@
 void
 ApplicationContainer::Start(Time start) const
 {
-    for (Iterator i = Begin(); i != End(); ++i)
+    for (auto i = Begin(); i != End(); ++i)
     {
         Ptr<Application> app = *i;
         app->SetStartTime(start);
@@ -101,7 +101,7 @@
 void
 ApplicationContainer::StartWithJitter(Time start, Ptr<RandomVariableStream> rv) const
 {
-    for (Iterator i = Begin(); i != End(); ++i)
+    for (auto i = Begin(); i != End(); ++i)
     {
         Ptr<Application> app = *i;
         double value = rv->GetValue();
@@ -113,7 +113,7 @@
 void
 ApplicationContainer::Stop(Time stop) const
 {
-    for (Iterator i = Begin(); i != End(); ++i)
+    for (auto i = Begin(); i != End(); ++i)
     {
         Ptr<Application> app = *i;
         app->SetStopTime(stop);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/net-device-container.cc ns-3.40/src/network/helper/net-device-container.cc
--- ns-3.39/src/network/helper/net-device-container.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/net-device-container.cc	2023-09-27 13:30:37.850839600 -0700
@@ -72,7 +72,7 @@
 void
 NetDeviceContainer::Add(NetDeviceContainer other)
 {
-    for (Iterator i = other.Begin(); i != other.End(); i++)
+    for (auto i = other.Begin(); i != other.End(); i++)
     {
         m_devices.push_back(*i);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/node-container.cc ns-3.40/src/network/helper/node-container.cc
--- ns-3.39/src/network/helper/node-container.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/node-container.cc	2023-09-27 13:30:37.850839600 -0700
@@ -28,7 +28,7 @@
 NodeContainer::GetGlobal()
 {
     NodeContainer c;
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         c.Add(*i);
     }
@@ -101,7 +101,7 @@
 void
 NodeContainer::Add(const NodeContainer& nc)
 {
-    for (Iterator i = nc.Begin(); i != nc.End(); i++)
+    for (auto i = nc.Begin(); i != nc.End(); i++)
     {
         m_nodes.push_back(*i);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/packet-socket-helper.cc ns-3.40/src/network/helper/packet-socket-helper.cc
--- ns-3.39/src/network/helper/packet-socket-helper.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/packet-socket-helper.cc	2023-09-27 13:30:37.850839600 -0700
@@ -28,7 +28,7 @@
 void
 PacketSocketHelper::Install(NodeContainer c) const
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Install(*i);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/packet-socket-helper.h ns-3.40/src/network/helper/packet-socket-helper.h
--- ns-3.39/src/network/helper/packet-socket-helper.h	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/packet-socket-helper.h	2023-09-27 13:30:37.850839600 -0700
@@ -20,7 +20,7 @@
 #ifndef PACKET_SOCKET_HELPER_H
 #define PACKET_SOCKET_HELPER_H
 
-#include "ns3/node-container.h"
+#include "node-container.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/simple-net-device-helper.cc ns-3.40/src/network/helper/simple-net-device-helper.cc
--- ns-3.39/src/network/helper/simple-net-device-helper.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/simple-net-device-helper.cc	2023-09-27 13:30:37.850839600 -0700
@@ -19,6 +19,8 @@
 
 #include "simple-net-device-helper.h"
 
+#include "trace-helper.h"
+
 #include "ns3/abort.h"
 #include "ns3/boolean.h"
 #include "ns3/config.h"
@@ -30,7 +32,6 @@
 #include "ns3/simple-channel.h"
 #include "ns3/simple-net-device.h"
 #include "ns3/simulator.h"
-#include "ns3/trace-helper.h"
 
 #include <string>
 
@@ -98,7 +99,7 @@
 {
     NetDeviceContainer devs;
 
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         devs.Add(InstallPriv(*i, channel));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/simple-net-device-helper.h ns-3.40/src/network/helper/simple-net-device-helper.h
--- ns-3.39/src/network/helper/simple-net-device-helper.h	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/simple-net-device-helper.h	2023-09-27 13:30:37.850839600 -0700
@@ -19,9 +19,10 @@
 #ifndef SIMPLE_NETDEVICE_HELPER_H
 #define SIMPLE_NETDEVICE_HELPER_H
 
+#include "net-device-container.h"
+#include "node-container.h"
+
 #include "ns3/attribute.h"
-#include "ns3/net-device-container.h"
-#include "ns3/node-container.h"
 #include "ns3/object-factory.h"
 #include "ns3/queue.h"
 #include "ns3/simple-channel.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/trace-helper.cc ns-3.40/src/network/helper/trace-helper.cc
--- ns-3.39/src/network/helper/trace-helper.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/trace-helper.cc	2023-09-27 13:30:37.850839600 -0700
@@ -438,7 +438,7 @@
 void
 PcapHelperForDevice::EnablePcap(std::string prefix, NetDeviceContainer d, bool promiscuous)
 {
-    for (NetDeviceContainer::Iterator i = d.Begin(); i != d.End(); ++i)
+    for (auto i = d.Begin(); i != d.End(); ++i)
     {
         Ptr<NetDevice> dev = *i;
         EnablePcap(prefix, dev, promiscuous);
@@ -449,7 +449,7 @@
 PcapHelperForDevice::EnablePcap(std::string prefix, NodeContainer n, bool promiscuous)
 {
     NetDeviceContainer devs;
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         for (uint32_t j = 0; j < node->GetNDevices(); ++j)
@@ -474,7 +474,7 @@
 {
     NodeContainer n = NodeContainer::GetGlobal();
 
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetId() != nodeid)
@@ -567,7 +567,7 @@
                                            std::string prefix,
                                            NetDeviceContainer d)
 {
-    for (NetDeviceContainer::Iterator i = d.Begin(); i != d.End(); ++i)
+    for (auto i = d.Begin(); i != d.End(); ++i)
     {
         Ptr<NetDevice> dev = *i;
         EnableAsciiInternal(stream, prefix, dev, false);
@@ -601,7 +601,7 @@
                                            NodeContainer n)
 {
     NetDeviceContainer devs;
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         for (uint32_t j = 0; j < node->GetNDevices(); ++j)
@@ -665,7 +665,7 @@
 {
     NodeContainer n = NodeContainer::GetGlobal();
 
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetId() != nodeid)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/helper/trace-helper.h ns-3.40/src/network/helper/trace-helper.h
--- ns-3.39/src/network/helper/trace-helper.h	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/helper/trace-helper.h	2023-09-27 13:30:37.850839600 -0700
@@ -18,9 +18,10 @@
 #ifndef TRACE_HELPER_H
 #define TRACE_HELPER_H
 
+#include "net-device-container.h"
+#include "node-container.h"
+
 #include "ns3/assert.h"
-#include "ns3/net-device-container.h"
-#include "ns3/node-container.h"
 #include "ns3/output-stream-wrapper.h"
 #include "ns3/pcap-file-wrapper.h"
 #include "ns3/simulator.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/address.h ns-3.40/src/network/model/address.h
--- ns-3.39/src/network/model/address.h	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/model/address.h	2023-09-27 13:30:37.850839600 -0700
@@ -20,9 +20,10 @@
 #ifndef ADDRESS_H
 #define ADDRESS_H
 
+#include "tag-buffer.h"
+
 #include "ns3/attribute-helper.h"
 #include "ns3/attribute.h"
-#include "ns3/tag-buffer.h"
 
 #include <ostream>
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/application.cc ns-3.40/src/network/model/application.cc
--- ns-3.39/src/network/model/application.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/network/model/application.cc	2023-09-27 13:30:37.850839600 -0700
@@ -22,8 +22,9 @@
 
 #include "application.h"
 
+#include "node.h"
+
 #include "ns3/log.h"
-#include "ns3/node.h"
 #include "ns3/nstime.h"
 #include "ns3/simulator.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/application.h ns-3.40/src/network/model/application.h
--- ns-3.39/src/network/model/application.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/application.h	2023-09-27 13:30:37.850839600 -0700
@@ -20,8 +20,9 @@
 #ifndef APPLICATION_H
 #define APPLICATION_H
 
+#include "node.h"
+
 #include "ns3/event-id.h"
-#include "ns3/node.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/buffer.cc ns-3.40/src/network/model/buffer.cc
--- ns-3.39/src/network/model/buffer.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/buffer.cc	2023-09-27 13:30:37.850839600 -0700
@@ -88,7 +88,7 @@
     NS_LOG_FUNCTION(this);
     if (IS_INITIALIZED(g_freeList))
     {
-        for (Buffer::FreeList::iterator i = g_freeList->begin(); i != g_freeList->end(); i++)
+        for (auto i = g_freeList->begin(); i != g_freeList->end(); i++)
         {
             Buffer::Deallocate(*i);
         }
@@ -173,8 +173,8 @@
     NS_ASSERT(reqSize >= 1);
     reqSize += ALLOC_OVER_PROVISION;
     uint32_t size = reqSize - 1 + sizeof(Buffer::Data);
-    uint8_t* b = new uint8_t[size];
-    Buffer::Data* data = reinterpret_cast<Buffer::Data*>(b);
+    auto b = new uint8_t[size];
+    auto data = reinterpret_cast<Buffer::Data*>(b);
     data->m_size = reqSize;
     data->m_count = 1;
     return data;
@@ -185,7 +185,7 @@
 {
     NS_LOG_FUNCTION(data);
     NS_ASSERT(data->m_count == 0);
-    uint8_t* buf = reinterpret_cast<uint8_t*>(data);
+    auto buf = reinterpret_cast<uint8_t*>(data);
     delete[] buf;
 }
 
@@ -582,7 +582,7 @@
 Buffer::Serialize(uint8_t* buffer, uint32_t maxSize) const
 {
     NS_LOG_FUNCTION(this << &buffer << maxSize);
-    uint32_t* p = reinterpret_cast<uint32_t*>(buffer);
+    auto p = reinterpret_cast<uint32_t*>(buffer);
     uint32_t size = 0;
 
     // Add the zero data length
@@ -654,7 +654,7 @@
 Buffer::Deserialize(const uint8_t* buffer, uint32_t size)
 {
     NS_LOG_FUNCTION(this << &buffer << size);
-    const uint32_t* p = reinterpret_cast<const uint32_t*>(buffer);
+    auto p = reinterpret_cast<const uint32_t*>(buffer);
     uint32_t sizeCheck = size - 4;
 
     NS_ASSERT(sizeCheck >= 4);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/byte-tag-list.cc ns-3.40/src/network/model/byte-tag-list.cc
--- ns-3.39/src/network/model/byte-tag-list.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/byte-tag-list.cc	2023-09-27 13:30:37.850839600 -0700
@@ -67,9 +67,9 @@
 ByteTagListDataFreeList::~ByteTagListDataFreeList()
 {
     NS_LOG_FUNCTION(this);
-    for (ByteTagListDataFreeList::iterator i = begin(); i != end(); i++)
+    for (auto i = begin(); i != end(); i++)
     {
-        uint8_t* buffer = (uint8_t*)(*i);
+        auto buffer = (uint8_t*)(*i);
         delete[] buffer;
     }
 }
@@ -366,11 +366,11 @@
             data->dirty = 0;
             return data;
         }
-        uint8_t* buffer = (uint8_t*)data;
+        auto buffer = (uint8_t*)data;
         delete[] buffer;
     }
-    uint8_t* buffer = new uint8_t[std::max(size, g_maxSize) + sizeof(ByteTagListData) - 4];
-    ByteTagListData* data = (ByteTagListData*)buffer;
+    auto buffer = new uint8_t[std::max(size, g_maxSize) + sizeof(ByteTagListData) - 4];
+    auto data = (ByteTagListData*)buffer;
     data->count = 1;
     data->size = size;
     data->dirty = 0;
@@ -391,7 +391,7 @@
     {
         if (g_freeList.size() > FREE_LIST_SIZE || data->size < g_maxSize)
         {
-            uint8_t* buffer = (uint8_t*)data;
+            auto buffer = (uint8_t*)data;
             delete[] buffer;
         }
         else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/channel-list.cc ns-3.40/src/network/model/channel-list.cc
--- ns-3.39/src/network/model/channel-list.cc	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/channel-list.cc	2023-09-27 13:30:37.850839600 -0700
@@ -162,7 +162,7 @@
 ChannelListPriv::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Ptr<Channel>>::iterator i = m_channels.begin(); i != m_channels.end(); i++)
+    for (auto i = m_channels.begin(); i != m_channels.end(); i++)
     {
         Ptr<Channel> channel = *i;
         channel->Dispose();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/network/model/nix-vector.h ns-3.40/src/network/model/nix-vector.h
--- ns-3.39/src/network/model/nix-vector.h	2023-07-05 14:23:48.061428300 -0700
+++ ns-3.40/src/network/model/nix-vector.h	2023-09-27 13:30:37.854839600 -0700
@@ -20,7 +20,8 @@
 #ifndef NIX_VECTOR_H
 #define NIX_VECTOR_H
 
-#include "ns3/buffer.h"
+#include "buffer.h"
+
 #include "ns3/ptr.h"
 #include "ns3/simple-ref-count.h"
 
